routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();
Route::get('/home', 'HomeController@index')->name('home');
//Route::get('/',function(){
//    return redirect()->to('/home');
//});
Route::get('new-password', 'Api\Client\AuthController@newPassword');
Route::post('password', 'Api\Client\AuthController@password');
Route::get('/logout', 'Auth\LoginController@logout');
// admin routes
Route::group(['prefix'=> 'admin','middleware'=>'auth'],function(){
    //user reset password
    Route::get('user/change-password','UserController@changePassword');
    Route::post('user/change-password','UserController@changePasswordSave');
    Route::resource('user','UserController');
    //Settings Routes
    Route::get('setting','SettingController@view');
    Route::post('setting','SettingController@update');
    Route::resource('contacts','ContactController',['only' => ['index','destroy','show']]);
    Route::resource('slider', 'SliderController');
        Route::resource('category', 'CategoryController');
    Route::resource('photo', 'PhotoController');
    Route::resource('book','BookController');
    Route::resource('client','ClientController');
    Route::resource('entry','EntryController');
    Route::get('book/{id}/approve', 'BookController@approve');
    Route::get('book/{id}/un-approve', 'BookController@unApprove');
    Route::get('client/{id}/approve', 'ClientController@approve');
    Route::get('client/{id}/un-approve', 'ClientController@unApprove');
});

Route::group(['middleware'=>'language'], function(){
    //Language Controller 
    Route::get('lang/{lang}', 'LanguageController@switchLang');

Route::get('/','FrontController@index');
Route::post('client_login','FrontController@postLogin')->name('client_login');
Route::post('client_register','FrontController@postRegister');
Route::post('client/logout','FrontController@logout');
Route::get('client/entries','FrontController@entries')->name('client.entries');

Route::group(['prefix'=> 'client','middleware'=>'auth:client'],function() {
    Route::get('books','FrontController@books');
    Route::get('book/{id}','FrontController@book');
    Route::get('add_entry/{id}','FrontController@getEntry');
    Route::get('edit_draft/{id}','FrontController@getDraft');
    Route::post('add_entry','FrontController@addEntry');
    Route::get('suggest_book','FrontController@getSuggestBook');
    Route::post('suggest_book','FrontController@suggestBook');
    Route::get('old_work','FrontController@oldWork');
    Route::get('my_entry','FrontController@myEntry');

});
});

app/Models/Slider.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Slider extends Model 
{

    protected $table = 'sliders';
    public $timestamps = true;
    protected $fillable = array('en_title','ar_title', 'en_description','ar_description','thumbnail');


    public static function boot()
    {
        parent::boot();
        self::deleting(function($model){
            if(file_exists($model->thumbnail))
                unlink($model->thumbnail);
        });
    }

}

app/Http/Controllers/SliderController.php
<?php

namespace App\Http\Controllers;

use App\Models\Slider;
use Illuminate\Http\Request;
use Response;

class SliderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $sliders = Slider::latest()->paginate(20);
        return view('admin.sliders.index',compact('sliders'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Slider $model)
    {
        return view('admin.sliders.create',compact('model'));
            }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'en_title'             => 'required',
            'ar_title'             => 'required',
            'thumbnail'         => 'required|mimes:jpeg,jpg,png',
        ]);
        $slider = Slider::create($request->except('thumbnail'));
        $image = $request->file('thumbnail');
        $destinationPath = public_path().'/uploads/sliders';
        $extension = $image->getClientOriginalExtension(); // getting image extension
        $name = time().''.rand(11111,99999).'.'.$extension; // renameing image
        $image->move($destinationPath, $name); // uploading file to given
        $slider->update(['thumbnail' => 'uploads/sliders/'.$name]);
        flash()->success(' slider has been added successfully');
        return redirect('admin/slider');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    
    public function edit($id)
    {
        $model = Slider::findOrFail($id);
        return view('admin.sliders.edit',compact('model'));
    }

    public function update(Request $request , $id)
    {
        $this->validate($request, [
            'en_title'             => 'required',
            'ar_title'             => 'required',
            'thumbnail'         => 'mimes:jpeg,jpg,png',
        ]);
        $slider = Slider::findOrFail($id);
        $slider->update($request->except('thumbnail'));
        if ($request->hasFile('thumbnail'))
        {
            if (file_exists($slider->thumbnail))
            {
                unlink($slider->thumbnail); //unlink old image
            }
            $image = $request->file('thumbnail');
            $destinationPath = public_path().'/uploads/sliders';
            $extension = $image->getClientOriginalExtension(); // getting image extension
            $name = time().''.rand(11111,99999).'.'.$extension; // renameing image
            $image->move($destinationPath, $name); // uploading file to given
            $slider->update(['thumbnail' => 'uploads/sliders/'.$name]);
        }
        flash()->success('slider has been updated successfully');
        return redirect('admin/slider/'.$id.'/edit');

    }

    public function destroy($id)
    {
        $slider = Slider::findOrFail($id);
        $slider->delete();
        $data = [
            'status' => 1,
            'msg' => 'slider has been deleted successfully',
            'id' => $id
        ];
        return Response::json($data, 200);
    }
}

resources/views/admin/sliders/create.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => ' Sliders',
                                'page_description'  => '  New thumbnail'
                                ])
@section('content')
        <!-- general form elements -->
<div class="box box-primary">
    <!-- form start -->
    {!! Form::model($model,[
                            'action'=>'SliderController@store',
                            'id'=>'myForm',
                            'role'=>'form',
                            'method'=>'POST',
                            'files'=>true
                            ])!!}

    <div class="box-body">

        @include('admin.sliders.form')

        <div class="box-footer">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>

    </div>
    {!! Form::close()!!}

</div><!-- /.box -->

@endsection

resources/views/admin/sliders/edit.blade.php
@extends('admin.layouts.main',[
                                'page_header'       => ' Sliders',
                                'page_description'  => ' Edit thumbnail'
                                ])
@section('content')
        <!-- general form elements -->
<div class="box box-primary">
    <!-- form start -->
    {!! Form::model($model,[
                            'action'=>['SliderController@update',$model->id],
                            'id'=>'myForm',
                            'role'=>'form',
                            'method'=>'PUT',
                            'files'=>true
                            ])!!}

    <div class="box-body">

        @include('admin.sliders.form')

        <div class="box-footer">
            <button type="submit" class="btn btn-primary">Save</button>
        </div>

    </div>
    {!! Form::close()!!}

</div><!-- /.box -->

@endsection

resources/views/admin/sliders/form.blade.php
@include('admin.layouts.partials.validation-errors')
@include('flash::message')
{!! \App\Ibnfarouk\MyClasses\Field::text('en_title',' English Title ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::text('ar_title','Arabic Title ') !!}

{!! \App\Ibnfarouk\MyClasses\Field::fileWithPreview('thumbnail','Thumbnail ') !!}
@if($model->thumbnail)
    <div class="col-md-4">
        <img src="{{asset($model->thumbnail)}}" alt="" class="img-responsive thumbnail">
    </div>
@endif
<div class="clearfix"></div>
{!! \App\Ibnfarouk\MyClasses\Field::editor('en_description','English description ') !!}
{!! \App\Ibnfarouk\MyClasses\Field::editor('ar_description','Arabic description ') !!}

resources/views/admin/sliders/index.blade.php
@extends('admin.layouts.main',[
								'page_header'		=> 'Slider',
								'page_description'	=> 'show thumbnails'
								])
@section('content')
    <div class="box box-primary">
        <div class="box-header">
            <div class="pull-left">
                <a href="{{url('admin/slider/create')}}" class="btn btn-primary">
                    <i class="fa fa-plus"></i>New Slider
                </a>
            </div>
            <div class="clearfix"> </div>
        </div>
        <div class="box-body">
            @include('flash::message')
        @if(!empty($sliders) && count($sliders)>0)
        <div class="table-responsive">
            <table class="table table-bordered">
                <thead>
                <th>#</th>
                <th> English Title</th>
                <th> Arabic Title</th>
                <th> thumbnail </th>
                <th class="text-center">Edit</th>
                <th class="text-center">Delete</th>
                </thead>
                <tbody>
                    @php $count = 1; @endphp
                    @foreach($sliders as $slider)
                        <tr id="removable{{$slider->id}}">
                            <td>{{$count}}</td>
                            <td> {{$slider->en_title}}</td>
                            <td> {{$slider->ar_title}}</td>
                            <td> <a href="{{asset($slider->thumbnail)}}" data-lightbox="image-1" data-title="{{$slider->title}}">
                                    <img src="{{asset($slider->thumbnail)}}" alt="" style="height: 70px;"></a> </td>
                            <td class="text-center"><a href="{{url('admin/slider/'.$slider->id. '/edit')}}" class="btn btn-xs btn-success"><i class="fa fa-edit"></i></a></td>
                             <td class="text-center">
                                <button id="{{$slider->id}}" data-token="{{ csrf_token() }}" data-route="{{URL::route('slider.destroy',$slider->id)}}"  type="button" class="destroy btn btn-danger btn-xs"><i class="fa fa-trash-o"></i></button>
                            </td>
                        </tr>
                        @php $count ++; @endphp
                    @endforeach
                </tbody>
            </table>
        </div>
            {!! $sliders->render() !!}
        @else
                <div>
                    <h3 class="text-info" style="text-align: center">No Data To Show </h3>
                </div>
            @endif
    </div>
</div>
@stop